//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <Menus.hpp>
#include <Grids.hpp>
#include <Dialogs.hpp>
#include <ImgList.hpp>
#include "Unit3.h"
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *MainMenu1;
        TMenuItem *Game1;
        TMenuItem *New1;
        TMenuItem *Open1;
        TMenuItem *Save1;
        TMenuItem *Check1;
        TMenuItem *N1;
        TMenuItem *Exit1;
        TMenuItem *Tools1;
        TMenuItem *Paint1;
        TMenuItem *Mark1;
        TMenuItem *Erase1;
        TMenuItem *Measure1;
        TMenuItem *View1;
        TMenuItem *ZoomIn1;
        TMenuItem *ZoomOut1;
        TOpenDialog *OpenDialog1;
        TMenuItem *Options1;
        TMenuItem *Paint2;
        TMenuItem *Mark2;
        TSaveDialog *SaveDialog1;
        TMenuItem *N2;
        TMenuItem *Prompt1;
        TCoolBar *CoolBar;
        TPanel *ButtonPanel;
        TSpeedButton *NewButton;
        TSpeedButton *OpenButton;
        TSpeedButton *SaveButton;
        TSpeedButton *CheckButton;
        TSpeedButton *PaintButton;
        TSpeedButton *MarkButton;
        TSpeedButton *EraseButton;
        TSpeedButton *MeasureButton;
        TSpeedButton *ZoominButton;
        TSpeedButton *ZoomoutButton;
        TSpeedButton *PromptButton;
        TDrawGrid *MainGrid;
        TPanel *StatusPanel;
        TLabel *Label1;
        TLabel *SizeLabel;
        TLabel *Label3;
        TLabel *SelectLabel;
        TLabel *Label2;
        TLabel *PosLabel;
        TMenuItem *AI1;
        TMenuItem *Ideas1;
        TMenuItem *AItotalscan1;
        TSpeedButton *AIButton;
        TMenuItem *Help1;
        TMenuItem *About1;
        TMenuItem *Rules1;
        TMenuItem *N3;
        TMenuItem *Undo1;
        TMenuItem *Saveasnew1;
        TMenuItem *N4;
        TMenuItem *Creating1;
        TMenuItem *New2;
        TMenuItem *Adjust1;
        TMenuItem *Openforediting1;
        void __fastcall NewButtonClick(TObject *Sender);
        void __fastcall OpenButtonClick(TObject *Sender);
        void __fastcall SaveButtonClick(TObject *Sender);
        void __fastcall CheckButtonClick(TObject *Sender);
        void __fastcall PaintButtonClick(TObject *Sender);
        void __fastcall MarkButtonClick(TObject *Sender);
        void __fastcall EraseButtonClick(TObject *Sender);
        void __fastcall MeasureButtonClick(TObject *Sender);
        void __fastcall ZoominButtonClick(TObject *Sender);
        void __fastcall ZoomoutButtonClick(TObject *Sender);
        void __fastcall New1Click(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall Exit1Click(TObject *Sender);
        void __fastcall ZoomIn1Click(TObject *Sender);
        void __fastcall ZoomOut1Click(TObject *Sender);
        void __fastcall MainGridDrawCell(TObject *Sender, int ACol,
          int ARow, TRect &Rect, TGridDrawState State);
        void __fastcall Paint2Click(TObject *Sender);
        void __fastcall MainGridMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall MainGridMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall Paint1Click(TObject *Sender);
        void __fastcall Mark1Click(TObject *Sender);
        void __fastcall Erase1Click(TObject *Sender);
        void __fastcall Measure1Click(TObject *Sender);
        void __fastcall Mark2Click(TObject *Sender);
        void __fastcall MainGridKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall Open1Click(TObject *Sender);
        void __fastcall Save1Click(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall Check1Click(TObject *Sender);
        void __fastcall PromptButtonClick(TObject *Sender);
        void __fastcall Prompt1Click(TObject *Sender);
        void __fastcall AI1Click(TObject *Sender);
        void __fastcall AIButtonClick(TObject *Sender);
        void __fastcall AItotalscan1Click(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
        void __fastcall Rules1Click(TObject *Sender);
        void __fastcall Undo1Click(TObject *Sender);
        void __fastcall Saveasnew1Click(TObject *Sender);
        void __fastcall New2Click(TObject *Sender);
        void __fastcall Openforediting1Click(TObject *Sender);
        void __fastcall Adjust1Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
        int sizeX,sizeY;
        char* pattern;
        char* picture;
        char* headX;
        char* headY;
        char* numX;
        char* numY;
        int tool;
        void makegrid();
        void resize();
        void __fastcall paint(TCanvas*,TRect&);
        void __fastcall mark(TCanvas*,TRect&);
        void __fastcall erase(TCanvas*,TRect&);
        void __fastcall measure(TCanvas*,TRect&);
        struct
        {
         int Shape;
         TColor Color;
        }
        paintshape;
        struct
        {
         int Shape;
         TColor Color;
        }
        markshape;
        bool saved;
        void AIscan(bool one);
        AI* ai;
        void __fastcall AppIdle(TObject *Sender, bool &Done);
        char* undoBuf;
        TGridRect undoRect;
        void __fastcall StoreUndo();
        void __fastcall Undo();
        void __fastcall DeleteUndo();
        AnsiString File;
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
